###########################################################
# Created: seg 11 dez 2023 16:04:54
#
# Author: Maycon Sambinelli, msambinelli@gmail.com
#
###########################################################
 
TIMEOUT=360 # 6 min

mkdir -p battle

echo "Programa; Resultado (s)"

ls competitors/* | while read x; do

  program=$(basename $x)

  mkdir -p battle/$program

  certo=1

  for i in $(seq 3); do
    timeout $TIMEOUT /usr/bin/time -f "%e" -o ./battle/$program/exectime$i.out  competitors/$program < ./instances/Goliath.in > ./battle/$program/Goliath$i.out  

    if [ $? -eq 124 ]; then
      echo "${program}; desclassificado (timeout)"
      certo=0
      break
    fi

    diff ./instances/Goliath.out ./battle/$program/Goliath$i.out > /dev/null 
    if [ "$?" == "1" ]; then
      echo "${program}; desclassificado (incorreto)"
      certo=0
      break
    fi
  done

  if [ $certo -eq 1 ]; then 
    avgtime=$(cat ./battle/$program/exectime*.out | awk '{total+=$1}END{print total/NR}')
    echo "$program; $avgtime"
  fi
done

